diff -Naur stunnel-4.54/src/ctx.c stunnel-4.54-wildcardSNI/src/ctx.c
--- stunnel-4.54/src/ctx.c	2012-08-19 19:43:09.000000000 +0000
+++ stunnel-4.54-wildcardSNI/src/ctx.c	2012-11-29 03:20:31.596207969 +0000
@@ -194,6 +194,29 @@
 #endif /* USE_LIBWRAP */
             return SSL_TLSEXT_ERR_OK;
         }
+
+    /* If we didn't find the exact servername above, try to match against wildcard certs */
+    for(list=section->servername_list_head; list; list=list->next)
+        if(!strncmp("*",list->servername,1)) {
+            const char *basename = list->servername;
+            basename++;
+            char *foundbase = strcasestr(servername,basename);
+            if(foundbase && !strcasecmp(foundbase, basename)) {
+                c=SSL_get_ex_data(ssl, cli_index);
+                c->opt=list->opt;
+                SSL_set_SSL_CTX(ssl, c->opt->ctx);
+                SSL_set_verify(ssl, SSL_CTX_get_verify_mode(c->opt->ctx),
+                    SSL_CTX_get_verify_callback(c->opt->ctx));
+                s_log(LOG_NOTICE, "SNI: switched to section %s",
+                    c->opt->servname);
+#ifdef USE_LIBWRAP
+                accepted_address=s_ntop(&c->peer_addr, c->peer_addr_len);
+                libwrap_auth(c, accepted_address); /* retry on a service switch */
+                str_free(accepted_address);
+#endif /* USE_LIBWRAP */
+                return SSL_TLSEXT_ERR_OK;
+            }
+        }
     s_log(LOG_ERR, "SNI: no service defined for server %s", servername);
     return SSL_TLSEXT_ERR_ALERT_FATAL;
 }
